var socketIP = networkSTA;  // Station mode
var publishQueue = [];  // queue with items to plublish at the end of function commandMsg()
var stopWS = true;  // true: avoid automatic connection
var rbutton = 'rbnSTA';  // holt active radio button

disCon();

/********** proceed data **********/
function commandMsg(msg) {  // is used by WebsocketClient.js
  wIn = msg;
  if (!(msg.startsWith('|') && msg.endsWith('|'))) return;
  if (msg.startsWith('|INFO|')) {  // cls info
  	$('#info').text('');
  	return;
  }
  if (msg.startsWith('|@|')) {  // append text to info
  	$('#info').append(msg.substring(3, msg.length - 1));
  	return;
  }
  parse();
  var d = new Date(parseInt(values[stamp],10));
  $('#respons').html(msg+  '<br>' + outNames() + d );
  if (values[mode] == "1") {  // respons from IoT slave
    // ##### update ...
    // after update : send next message
    if (typeof publishQueue != "undefined" && publishQueue.length != 0) publishIt('');
  } 
}

/********** network radio buttons **********/
$('input[type=radio]').change(function(e) {
  if (!isConnected) {
    if (this.id == 'rbnSTA') {
      socketIP = networkSTA;
      rbutton = 'rbnSTA';
    } else {
      socketIP = networkWWW;
      rbutton = 'rbnWww';
    }
  }
  else $('#' + rbutton ).prop('checked', true);
});

/********** dis/connect buttons **********/
$('#btnConnect').click(function() {   // connect to server
  stopWS = false;
  clearFields();
  // 'isConnected = true' is set in file WebsocketClient.js
  if (!isConnected) {
    init();
  }
});

$('#btnDisConnect').click(function() {  // disconnect fom server
  stopWS = true;
  clearFields();
  if (isConnected) {  // 'isConnected = false' is set in file WebsocketClient.js
    websocket.close();
    websocket = null; 
  }
});

/********** commands **********/
$('#btnSend').click(function() {  // connect to server
  if (!isConnected) {
    $('#toServer').text('NOT connected!!!');
    while (publishQueue.length) publishQueue.shift();  // clear Queue
    return;
  }
  clearFields();
  
  values[to]    = $('#inpTo').val();
  values[from]  = 'WB';
  values[func]  = $('#inpFunc').val();
  values[cmd]   = $('#inpCmd').val();
  values[dat1]  = $('#inpData1').val();
  values[dat2]  = $('#inpData2').val();
  values[dat3]  = $('#inpData3').val();
  values[dat4]  = $('#inpData4').val();
  values[stamp] = String(Date.now());
  values[mode]  = $('#chbMode').is(':checked') ? '1' : '0';

  var n = [to, from, func, cmd, dat1, dat2, dat3, dat4, stamp, mode];
  publishIt(out(n, n.length)); 
});

/********** publish **********/
function publishIt(msg) {
  if (msg.length) publishQueue[publishQueue.length] = msg;
  if (publishQueue.length == 1) {  // only one item in Queue?
    if (!isConnected) {clearFields(); return;}  // if 'false' then clear old messages
    $('#toServer').text(publishQueue[0]);   // show message
    publish(publishQueue[0]);  // send message to server
    publishQueue.shift();
  }
}
  
/********** diverse **********/
function errorMsg(error) {  // show Websocket error
  $('#respons').text('ERROR');
}

function disCon() {  // show connected or disconnected
  $('#connect').text(isConnected ? 'connected' : 'disconnected'); 
}

function clearFields() {  // clear old messages
  $('#toServer').text('');
  $('#respons').text('');
}

