#include <simpleAdcADS1115.h>

const uint8_t sdaPin = D2,  // pin: SDA->D2
              sclPin = D1,  // pin: SCL->D1
              port = 0;     // the ADS1115 port 0-3, 4-7, 8-11, 12-15
double vcc = 3.320;         // measured VCC on ADS1115 (you have to measure it by yourself)

simpleADC adc = simpleADC(vcc);

void setup() {
  Serial.begin(115200);
//  Serial.setDebugOutput(true); 
  Serial.println("\n...\n");

  Wire.begin(sdaPin, sclPin);
  uint16_t maxSteps = adc.maxSteps;       // number of steps from 0 to VCC (on a Arduino fixed 1023)
                                          //   use this value on Thermistor calculation
  double   voltStep = adc.voltStep;       // VCC / max. steps (resolution)
  printf("port 0 - maxSteps: %d, voltStep: %s\n", maxSteps, String(voltStep,7).c_str());
}

void loop() {
  uint16_t steps = adc.getAdc(port);  // the measured ADC value
                                      //   use this value on Thermistors calculation
  double volt = adc.getVolt(port);    // the volt value (voltStep * measured ADC value)
  printf("Volt: %s, steps: %d \n", String(volt, 3).c_str(), steps);
  delay(5000);
}
