#include "simpleAdcADS1115.h"

/** get the steps **/
uint16_t simpleADC::getAdc(uint8_t p) {
  uint8_t module = p / 4 + adressADS,  // get module 0-3
            port = p % 4;              // get port 0-3
  uint32_t steps = 0;
  /** set the A-port bits (A0-A3) **/
  writeADS[0] = (writeADS[0] & 0b10001111) | portADS[port];  // OR-ing MSB with the port value(A0-A3)
  /** set ADS config **/
  Wire.beginTransmission(module);
  Wire.write(1);            // set config register, operating settings
  Wire.write(writeADS[0]);  // MSB
  Wire.write(writeADS[1]);  // LSB
  Wire.endTransmission();
  delay(10);
  /** get ADC **/
  Wire.beginTransmission(module);
  Wire.write(0);             // set conversion register, contains the result of the last conversion
  Wire.endTransmission();
  /** get the 16 bits **/
  Wire.requestFrom(module, (uint8_t)2);
  /** read and convert results **/
  steps = Wire.read() << 8 | Wire.read();  // shift MSB 8 bits to left and add the LSB bits
  return (steps > maxSteps ? 0 : steps);
}

/** get the voltage **/
double simpleADC::getVolt(uint8_t p) {
  return voltStep * getAdc(p);
}
