#include <simpleDegreesSteps.h>

Degrees degr( D5,   // stepPin1, stepper pins on WeMos/NodeMCU/...  (ESP8266 GPIO 14/12/13/15)
              D6,   // stepPin2
              D7,   // stepPin3
              D8,   // stepPin4
              D0,   // homePin, microswitch home position
             264);  // endPos, 270* - 6* -  stop -3* before max potentiometer angle

void setup() {
  Serial.begin(115200);
//  Serial.setDebugOutput(true); 
  Serial.println("\n...\n");

  /** This example must print this:
   * degPos: 135
   * degPos: 48
   * degPos: 0
   * degPos: 264
   **/
  
  uint16_t p;  // to get the current position in degrees
  boolean ok;
  ok = degr.findHome();         // find the home position (microswitch)
  if (ok) {
    ok = degr.toDegree(135);      // turn potentiometer to 135 degrees
    p = degr.degPos;              // get current position in degrees
    printf("degPos: %u\n", p);
    ok = degr.toDegree(48);       // turn potentiometer to 48 degrees
    p = degr.degPos;
    printf("degPos: %u\n", p);
    ok = degr.toDegree(degr.homePos);  // turn potentiometer to homePos
    p = degr.degPos;
    printf("degPos: %u\n", p);
    ok = degr.toDegree(degr.endPos);   // turn potentiometer to endPos
    p = degr.degPos;
    printf("degPos: %u\n", p);
  }
}

void loop() {
}
