#include "simpleDegreesSteps.h"

Degrees::Degrees(uint8_t _stepPin1,
                 uint8_t _stepPin2, 
                 uint8_t _stepPin3, 
                 uint8_t _stepPin4, 
                 uint8_t _homePin,
                 uint16_t _endPos) {
  stp = new StepperSteps (
                    _stepPin1,
                    _stepPin2, 
                    _stepPin3, 
                    _stepPin4,
                    _homePin,
                    -(_endPos),
                    false,
                    1,
                    1);
  endPos = _endPos;
  findHome();
}

boolean Degrees::findHome() {
  homeDetected = false;
  stp->gotoHome();
  if (stp->stepPos == 0) homeDetected = true;
  return homeDetected; 
}

/** turn to the requested position in degrees **/
boolean Degrees::toDegree(uint16_t deg) {
  if (!homeDetected || deg < homePos || deg > endPos) return false;
  if (deg == degPos) return true;
  double steps = deg * oneDegree - degPos * oneDegree;
  degPos = deg;
  stp->stepper(steps);
  return true;  
}

