#ifndef SIMPLEDEGREES_H
#define SIMPLEDEGREES_H

#include <Arduino.h>
#include <simpleStepperSteps.h>

class Degrees {
  public:  
    Degrees(uint8_t _stepPin1,
            uint8_t _stepPin2, 
            uint8_t _stepPin3, 
            uint8_t _stepPin4, 
            uint8_t _homePin, 
            uint16_t _endPos
    );
    
    boolean toDegree(uint16_t);
    boolean findHome();
    
    const uint16_t homePos =   0;  // 270* - 6* -  stop +3* before min potentiometer angle (micro switch)
    uint16_t       endPos =  264;  // 270* - 6* -  stop -3* before max potentiometer angle
    double degPos = 0.0;  // current position in degrees

  private:
    const double oneDegree = 1.422222222;  // (4096 / (8 * 360)) = 1.42... steps/degree
    boolean homeDetected = false;

    StepperSteps *stp;
};

#endif


