// =============================  https://github.com/esp8266/Arduino
#include <SoftwareSerial.h>       // you can use direct wired Serial communication between the WEB module and this Master Node
const uint8_t txPin = D6,         // pin: TX->D6
              rxPin = D5;         // pin: RX->D5
String n = "\n>";
char c = ' ';

/** TX, RX, inverse, buffer size **/
SoftwareSerial swSer(rxPin, txPin, false, 256);

void setup() {
  Serial.begin(115200);
  swSer.begin(38400);
  Serial.println("\n...\n");
  Serial.print(
    "- power HC-05 OFF \n"
    "- push and hold the HC-05 button \n"
    "- power HC-05 ON \n"
    "- release the HC-05 button \n"
    "- the HC-05 LED flash 1 sec ON/OFF \n\n"
    "- set monitor to \"Both NL & CR\"!!!"
    " type: AT (Send)\n"
    "if reation \"OK\" then set Slave or Master\n"
    "(send AT+ORGL to set module original state\n\n");
  Serial.print(
    "SLAVE CONFIG\n============\n"
    "AT+RMAAD               (clear paired devices)\n"
    "AT+ROLE=0              (set as slave)\n"
    "AT+ADDR                (get address from master)\n"
    "AT+UART=115200,0,0     (baud rate)\n"
    "AT+INIT                (start)\n\n"
    "MASTER CONFIG\n=============\n"
    "AT+RMAAD               (clear paired devices)\n"
    "AT+ROLE=1              (set as master)\n"
    "AT+CMODE=0             (address binding)\n"
    "AT+BIND=xxxx,xx,xxxxxx (address from slave, use comma, NO COLON)\n"
    "AT+UART=115200,0,0     (baud rate)\n"
    "AT+INIT                (start)\n\n");
}

void loop() {
  while (swSer.available()) {
    Serial.print((char)swSer.read());
  }
  if (Serial.available()) {
    c = Serial.read();
    swSer.write(c);
    Serial.print(n);
    Serial.write(c);
    if (c == 10) n = "\n>";
    else n = "";
  }