// =============================  https://github.com/esp8266/Arduino
#include <SoftwareSerial.h>       // you can use direct wired Serial communication between the WEB module and this Master Node
const uint8_t txPin = D6,         // pin: TX->D6
              rxPin = D5;         // pin: RX->D5
String n = "\n>";
char c = ' ';

/** TX, RX, inverse, buffer size **/
SoftwareSerial swSer(rxPin, txPin, false, 256);

void setup() {
  Serial.begin(115200);
  swSer.begin(38400);
  Serial.println("\n...\n");
  Serial.print(
    "Bluetooth OTA and terminal/monitor\n"
    "    Arduino and/or ESP8266-nn\n"
    "==================================\n"
    "- power HC-05 OFF \n"
    "- push and hold the HC-05 button \n"
    "- power HC-05 ON \n"
    "- release the HC-05 button \n"
    "- the HC-05 LED flash 1 sec ON/OFF \n\n"
    "- set monitor to \"Both NL & CR\"!!!"
    " type: AT (Send)\n"
    "if reation \"OK\" then set command:\n");
  Serial.print(
    "UPLOAD CONFIG\n=============\n"
    "AT+ORGL\n"             // resets the module to the factory default settings
    "AT+ROLE=0\n"           // slave mode
    "AT+CMODE=1\n"          // auto connection on start.
    "AT+UART=115200,0,0\n"  // set the baud rate used for serial UART commincation.
    "AT+NAME=esp8266\n"     // change the modules name to newName
    "AT+PSWD=esp8266\n"     // set the PIN code used for pairing
    "AT+RESET");            // start HC-05 module
}

void loop() {
  while (swSer.available()) {
    Serial.print((char)swSer.read());
  }
  if (Serial.available()) {
    c = Serial.read();
    swSer.write(c);
    Serial.print(n);
    Serial.write(c);
    if (c == 10) n = "\n>";
    else n = "";
  }
}
