
/*************************************************
 * NHS 433MHz radio by Ewald Kendziorra sr, 2017 *
 *************************************************/
 
//  KaKu, what does this means?
/** KaKu: 433MHz http://www.klikaanklikuit.nl/home/ modules.
      KaKu = Klik Aan Klik Uit
          translated
      CoCo = Click On Click Off
    You can use other brands!
    Kaku modules use the library from https://bitbucket.org/fuzzillogic/433mhzforarduino/wiki/Home
    When using other brands you can easily change the libraries and receive/tramsmit code.
 **/

#include "receiver.h"

void initChain() {
  /** interrupt **/
  RemoteReceiver::init(-1, 3, receiveOld);     // -1: manage iterrupts by "InterruptChain"
  NewRemoteReceiver::init(-1, 2, receiveNew);  //     so we can use the Old and New module simultaneous
  InterruptChain::setMode(0, CHANGE);
  InterruptChain::addInterruptCallback(0, RemoteReceiver::interruptHandler);
  InterruptChain::addInterruptCallback(0, NewRemoteReceiver::interruptHandler);
}

void receiveOld(unsigned long _code, unsigned int _period) {  // can't uint32/16_t ?!
  strcpy(code, String(_code).c_str());
  strcpy(period, String(_period).c_str());
  strcpy(address, " ");
  strcpy(groupBit, " ");
  strcpy(unit, " ");
  strcpy(dimLevelPresent, " ");
  strcpy(dimLevel, " ");
  received();
}

void receiveNew(NewRemoteCode receivedCode) {
  strcpy(code, " ");
  strcpy(period, String(receivedCode.period).c_str());
  strcpy(address, String(receivedCode.address).c_str());
  strcpy(groupBit, String(receivedCode.groupBit).c_str());
  strcpy(unit, String(receivedCode.unit).c_str());
  strcpy(dimLevelPresent, String(receivedCode.dimLevelPresent).c_str());
  strcpy(dimLevel, String(receivedCode.dimLevel).c_str());
  received();
}

void received() {
  sprintf(str, "%10s%10s%10s%10s%10s%16s%10s\n", code, period, address, groupBit, unit, dimLevelPresent, dimLevel);
  Serial.print(str);
}

