#include "ESP8266FtpServer.h"

const char ssid[] = "edit_edit"@,
           password[] = "edit_edit"@,
           userPw[] = "esp8266";

ESP8266WebServer server(80);
FtpServer ftpSrv;

void handleRoot() {
  server.send(200, "text/plain", "hello from esp8266!");
}

void handleNotFound(){
  char message[] = "File Not Found\n\nURI: ";
  strcat(message, server.uri().c_str());
  strcat(message, "\nMethod: ");
  strcat(message, ((server.method() == HTTP_GET)?"GET":"POST"));
  strcat(message, "\nArguments: ");
  strcat(message, String(server.args()).c_str());
  for (uint8_t i=0; i<server.args(); i++){
    strcat(message, " ");
    strcat(message, server.argName(i).c_str());
    strcat(message, ": ");
    strcat(message, server.arg(i).c_str());
    strcat(message, "\n");
  }
  server.send(404, "text/plain", message);
}

void setup(void){
  Serial.begin(115200);
  WiFi.begin(ssid, password);
  Serial.println("\n");

  while (WiFi.status() != WL_CONNECTED) delay(500);
  printf("Connected to:\t  %s \nFileZilla Site Manager \n====================== \n", ssid);                                
  printf("Host:\t\t  %d.%d.%d.%d, Port: %d \n", WiFi.localIP()[0], WiFi.localIP()[1], WiFi.localIP()[2], WiFi.localIP()[3], 21);
  printf("Protocol:\t  %s \nEncryption:\t  %s \n", "FTP", "Only plain FTP (insecure)");
  printf("Logon type:\t  %s \nUser:\t\t  %s \nPassword type:\t  %s \n\n", "Normal", userPw, userPw);
  
  server.on("/", handleRoot);
  server.onNotFound(handleNotFound);
  server.begin();
  printf("%s \n", "HTTP server started");
  if (SPIFFS.begin()) {
    printf("%s \n", "SPIFFS opened!");
    ftpSrv.begin(userPw,userPw);
  }    
}

void loop(void){
  ftpSrv.handleFTP(); 
  server.handleClient(); 
}
