﻿/*********** ESP8266 MLX90614 temperature ***********
  ***************************************************
  * Ewald Kendziorra sr, 2016, http://kendziorra.nl *
  * License:        Free                            *
  * Publishing AFP: Only with this header file      *
  * Editing:        Free                            *
  * Guarantee:      No                              *
  * Using:          At your own risk                *
  * Support:        No                              *
  ***************************************************/

#include <Wire.h>
#include <MLX90614.h>

const uint8_t sdaPin = D2,
sclPin = D1;
/** interpolate and extrapolate temperatures offsets **/
// calibrate: ‪‬0*C(ice water) and 100*C(boiling water)
// temperature offset: 0*C,  100*C   (1*C is 1*K)
const float calibrateAmbient0C   = 0.0,
            calibrateAmbient100C = 0.0,
            calibrateObject0C    = 0.0,
            calibrateObject100C  = 0.0;

simpleMLX90614 tmpMLX = simpleMLX90614(calibrateAmbient0C, calibrateAmbient100C, calibrateObject0C, calibrateObject100C);

void setup() {
  Serial.begin(115200);
  Wire.begin();
  Serial.print("\n...\n");
  Wire.begin(sdaPin, sclPin);
}

void loop() {
  float ambientMlx = tmpMLX.getMlxTemp(tmpMLX.mlxAmbient),
    objectMlx = tmpMLX.getMlxTemp(tmpMLX.mlxObject);
  printf("Ambient: %s*K, %s*C, %s*F  Objec:  %s*K, %s*C, %s*F\n\n",
    String(ambientMlx, 2).c_str(), String((ambientMlx - 273.15), 2).c_str(), String((ambientMlx * 9 / 5 - 459.67), 2).c_str(),
    String(objectMlx, 2).c_str(), String((objectMlx - 273.15), 2).c_str(), String((objectMlx * 9 / 5 - 459.67), 2).c_str());
  delay(5000);
}
