/*********** ESP8266 MLX90614 temperature ***********
  ***************************************************
  * Ewald Kendziorra sr, 2016, http://kendziorra.nl *
  * License:        Free                            *
  * Publishing AFP: Only with this header file      *
  * Editing:        Free                            *
  * Guarantee:      No                              *
  * Using:          At your own risk                *
  * Support:        No                              *
  ***************************************************/

#include "MLX90614.h"

float simpleMLX90614::getMlxTemp(MLX reg) {
  Wire.beginTransmission(mlxAddress);
  Wire.write(reg);
  Wire.endTransmission(false);
  Wire.requestFrom(mlxAddress, 3);
  uint16_t k = Wire.read();
  k |= Wire.read() << 8;
  uint16_t n = Wire.read();
  if (reg == mlxAmbient) n = 0;
  else n = 1;
  /** interpolate and extrapolate temperatures correction **/
  return k * 0.02 + (mlxCalibrate[n][1] - mlxCalibrate[n][0]) / 100 + mlxCalibrate[n][0];
}
