/*********** ESP8266 MLX90614 temperature ***********
  ***************************************************
  * Ewald Kendziorra sr, 2016, http://kendziorra.nl *
  * License:        Free                            *
  * Publishing AFP: Only with this header file      *
  * Editing:        Free                            *
  * Guarantee:      No                              *
  * Using:          At your own risk                *
  * Support:        No                              *
  ***************************************************/

/** MLX90614: High precision non-contact temperature measurements
    -40 to 125 ˚C for sensor temperature
    -70 to 380 ˚C for object temperature
**/

#ifndef _MLX90614_
#define _MLX90614_
#include <Wire.h>

class simpleMLX90614
{
public:
  enum MLX {  // address and registers
    mlxAddress = 0x5A,
    mlxAmbient = 0x06,
    mlxObject = 0x07
  };
  simpleMLX90614(double a0, double a1, double o0, double o1)
  {
    mlxCalibrate[0][0] = a0; mlxCalibrate[0][1] = a1;
    mlxCalibrate[1][0] = o0; mlxCalibrate[1][1] = o1;
  };
  float getMlxTemp(MLX);
private:
  /** interpolate and extrapolate temperatures offsets **/
  float mlxCalibrate[2][2] = { {0.0, 0.0},    // AMBIENT   
                               {0.0, 0.0} };  // OBJECT                
};

#endif
