/** 28YBJ-48 DC 5V 4 Phase 5 Wire Stepper Motor With ULN2003 Driver Board - 4096 steps **/

#include <simpleStepperSteps.h>


StepperSteps stepper( D5,   // stepPin1, stepper pins on WeMos/NodeMCU/...  (ESP8266 GPIO 14/12/13/15)
                      D6,   // stepPin2
                      D7,   // stepPin3
                      D8,   // stepPin4
                      D0,   // homePin, microswitch HOME position
                      D3,   // (int16_t) nn>=0: endPin microswitch END or maximun number of rotations
                            //           nn<0: end position in steps (no END microswitch)
                   false,   // stepper mode, false: 512 steps is 360*, true: 4096 steps is 360* 
                       1,   // (uint8_t) stepper speed, delay in ms,  default 1, min: 1, max: 50
                       2);  // (uint16_t) The maximun number of rotations to find the home/end position (1-65535)

uint16_t stepPos,   // steps from HOME
         stepsEnd;  // number of steps from HOME to END

void setup() {
  Serial.begin(115200);
//  Serial.setDebugOutput(true); 
  Serial.println("\n...\n");
  
  /** Result is ENDed on the maximun number of two rotations (NO ENDswich detected)
    *   If pin D3 (microswitch) detected then [nnn] stepsEnd
    *   With NO pin D3, but -12345 (example value) then: The last posible step is 12345 
    * stepsEnd:       1024  (The last posible step, two rotations of 512 steps mode, NO ENDswich detected)
    * stepPos:        0
    * gotoHome:       0
    * gotoEnd:        1024
    * stepper -255:   769
    * stepTo 111:     111
    * stepper +255:   366
    **/
  
  /** basic usage **/
  stepsEnd = stepper.endPos;  // ENDswitch/ENDsteps or if ENDswitch NOT found position based on the maximun number of rotations 
  printf("stepsEnd: \t%d\n", stepsEnd);
  stepPos = stepper.stepPos;  // HOMEswitch or if HOMEswitch NOT found position based on the maximun number of rotations
  printf("stepPos: \t%d\n", stepPos);

  stepper.gotoHome();    // find HOME position switch (using the maximun number of rotations)
  stepPos = stepper.stepPos;
  printf("gotoHome: \t%d\n", stepPos);
  
  stepper.gotoEnd();     // find  END position switch (using the maximun number of rotations)
  stepPos = stepper.stepPos;
  printf("gotoEnd: \t%d\n", stepPos);
  
  stepper.stepper(-255);  // do n steps, 512 or 4096 steps is 360*
  stepPos = stepper.stepPos;
  printf("stepper -255: \t%d\n", stepPos);
  
  stepper.stepTo(111);  // go to step nn (from HOME), 512 or 4096 steps is 360*
  stepPos = stepper.stepPos;
  printf("stepTo 111: \t%d\n", stepPos);

  stepper.stepper(255);  // do n steps, 512 or 4096 steps is 360*
  stepPos = stepper.stepPos;
  printf("stepper +255: \t%d\n", stepPos);
}

void loop() {

}