#include "simpleTempDS18B20.h"

double simpleTemp::getTemp() {
  double t = -999.0;
  for (uint8_t i = 0; i < 3; i++) {
    if (sensors.isConnected(tempSensor)) break;
    else init();
  }
  sensors.requestTemperatures(); // ready for the next reading
  t = sensors.getTempC(tempSensor) + correction;
  return t;  // if value -999: temp is not read
}

void simpleTemp::init(){
  pinMode(oneWirePin, OUTPUT);
  sensors.begin();
  sensors.getAddress(tempSensor, 0);
  sensors.setResolution(tempSensor, 12);
}
