#ifndef SIMPLETEMPDS18B20_H
#define SIMPLETEMPDS18B20_H

#include <Arduino.h>
#include <OneWire.h>            // https://github.com/PaulStoffregen/
#include <DallasTemperature.h>  // https://github.com/milesburton/Arduino-Temperature-Control-Library

class simpleTemp {
  public:
    OneWire oneWire;
    DallasTemperature sensors;
    DeviceAddress tempSensor;
    simpleTemp(uint8_t _oneWirePin, double _correction) : oneWirePin(_oneWirePin), correction(_correction), oneWire(_oneWirePin), sensors(&oneWire) {
      init();
    }
    void init();
    double getTemp();

  private:
    uint8_t oneWirePin;
    double correction;    // temperature correction value 
};

#endif

