/** simpleTimeNtpWebRtcMillis **
 *  www.kendziorra.nl          *
 *  Ewald sr, 2018             *
 *  totally free to use        *
 *******************************/

#include "NtpMs.h"

WiFiUDP Udp;

void NtpMs::setTimestamp(time_t t) {;}  // DUMMY FUNCTION set time from UNIX timestamp
void NtpMs::correctTime(int32_t s) {;}  // DUMMY FUNCTION time correction in seconds

NtpMs::NtpMs(char * serverName, uint16_t port, uint16_t offset) {
  ntpServerName = serverName;
  localPort = port;
}

time_t NtpMs::getTimestamp() {
  calcMs();
  IPAddress timeServerIP; // NTP server address
  WiFi.hostByName(ntpServerName, timeServerIP);  // get address from pool
  Udp.begin(localPort);
  byte pcktBuf[48];
  memset(pcktBuf, 0, 48);
  pcktBuf[0] = 0b11100011;
  pcktBuf[2] = 6;
  pcktBuf[3] = 0xEC;
  pcktBuf[12] = 49;
  pcktBuf[13] = 0x4E;
  pcktBuf[14] = 49;
  pcktBuf[15] = 52;
  Udp.beginPacket(timeServerIP, 123);  // requests to port 123
  Udp.write(pcktBuf, 48);  // send the packed
  Udp.endPacket();
  uint32_t timeout = millis() + 2000;
  while (millis() < timeout) {  
    if (Udp.parsePacket() >= 48) {  // get udp packet
      Udp.read(pcktBuf, 48);  // get the time data
      Udp.stop();
      // convert four bytes starting at location 40 to a long integer
      UNIXtimestamp =  (uint32_t)pcktBuf[40] << 24;
      UNIXtimestamp |= (uint32_t)pcktBuf[41] << 16;
      UNIXtimestamp |= (uint32_t)pcktBuf[42] << 8;
      UNIXtimestamp |= (uint32_t)pcktBuf[43];
      UNIXtimestamp -= 2208988800UL;  // UTC/GMT timeSerial << "@" << endl;
      setTime(UNIXtimestamp);  // sync the Time
      // convert four bytes starting at location 44 to a long integer
      milliseconds =  (uint32_t)pcktBuf[44] << 24;
      milliseconds |= (uint32_t)pcktBuf[45] << 16;
      milliseconds |= (uint32_t)pcktBuf[46] << 8;
      milliseconds |= (uint32_t)pcktBuf[47];
      milliseconds = (int16_t)(milliseconds * 2.3283064365387E-07);
      return UNIXtimestamp;
    }
  }
  return 0;
}

void NtpMs::calcMs() {
  uint32_t stop, start, difference;
  stop = millis();
  start = startMillis;
  startMillis = millis();
  if(stop < start)  // overflow=true
    difference = (uint32_t)4294967295 - start + stop + 1;
  else                // overflow=false
    difference = stop - start; 
  difference += milliseconds; 
  milliseconds = difference % 1000;
  startMillis = millis() + 1; // + 0.001 sec. work time compensation
}

char * NtpMs::getMsTimestamp() { // timestamp STRING in millis (UNIX * 1000)
  char msT[14];  // timestamp in millis, 14 digits char string
  char m[4];
  calcMs();
  ultoa(now(), msT, 10);
  ultoa(milliseconds, m, 10);
  strcat(msT, "000");
  strcpy(msT + 13 - strlen(m), m);  // add millis to the UNIXtimestamp
  return msT;
}
