/** simpleTimeNtpWebRtcMillis **
 *  www.kendziorra.nl          *
 *  Ewald sr, 2018             *
 *  totally free to use        *
 *******************************/

#ifndef SIMPLENTPMS_H
#define SIMPLENTPMS_H

#include <ESP8266WiFi.h>
#include <WiFiUdp.h>
#include <TimeLib.h>               // https://github.com/PaulStoffregen/Time

class NtpMs {
  public:
 
    NtpMs(char * serverName, uint16_t port = 8888, uint16_t offset = 1800);
    time_t getTimestamp();        // get UNIX timestamp
    void setTimestamp(time_t t);  // DUMMY FUNCTION set time from UNIX timestamp
    void correctTime(int32_t s);  // DUMMY FUNCTION time correction in seconds
    char * getMsTimestamp();      // timestamp in millis, 14 digits char string

  private:    
    char * ntpServerName;    // NTP server name
    uint16_t localPort,      // local port to listen for UDP packets
             syncOffset,     // time sync after each n seconds; small value = more precision
             milliseconds;   // used for extended timestamp (3 digits)
    uint32_t startMillis,    // start millis for timer difference
             syncTime;       // time to sync
    time_t UNIXtimestamp;   // UNIX timestamp (10 digits)
    void calcMs();
};

#endif

