/** simpleTimeNtpWebRtcMillis **
 *  www.kendziorra.nl          *
 *  Ewald sr, 2018             *
 *  totally free to use        *
 *******************************/

#ifndef SIMPLE_TIME_H
#define SIMPLE_TIME_H

#include <Arduino.h>
#include <Wire.h>
#include <TimeLib.h>

inline uint8_t bcd2bin (uint8_t v) {return v - 6 * (v >> 4);} 
inline uint8_t bin2bcd (uint8_t v) { return v + 6 * (v / 10);}

class RtcMs {
 public:
    RtcMs();
    time_t getTimestamp();        // get UNIX timestamp
    void setTimestamp(time_t t);  // set time from UNIX timestamp
    void correctTime(int32_t s);  // time correction in seconds
    char * getMsTimestamp();      // timestamp in millis, 14 digits char string
    
  private:
    const uint8_t rtcAddr = 0x68,
                  cntrReg = 0x0e;
    uint16_t milliseconds = 0;        // used for extended timestamp (3 digits)
    uint32_t startMillis = millis();  // start millis for timer difference
    const uint16_t oneHour = 3600;
    const uint32_t oneDay  = 86400;
    uint8_t rtcReadByte(uint8_t regadd);
    void rtcWriteByte(uint8_t regadd, uint8_t val);
    void calcMs();
    time_t calcTimeStamp(uint8_t h, uint8_t m, uint8_t s, uint8_t D, uint8_t M, uint16_t Y);  // get UNIX time_t Time Stamp from hh:mm:ss DD-MM-YY
    uint16_t yearDay(uint8_t d, uint8_t m, uint16_t y);  // year days from date numbers
    boolean leapYear(uint16_t y);  // leap year?
};

#endif
