/** simpleTimeNtpWebRtcMillis **
 *  www.kendziorra.nl          *
 *  Ewald sr, 2018             *
 *  totally free to use        *
 *******************************/

#ifndef SIMPLE_RTC_H
#define SIMPLE_RTC_H

#include <Arduino.h>
#include <Wire.h>
#include <TimeLib.h>

inline uint8_t bcd2bin (uint8_t v) {return v - 6 * (v >> 4);} 
inline uint8_t bin2bcd (uint8_t v) { return v + 6 * (v / 10);}

class TimeMs {
 public:
    TimeMs();
    time_t getTimestamp();        // get UNIX timestamp
    void setTimestamp(time_t t);  // set time from UNIX timestamp
    void correctTime(int32_t s);  // time correction in seconds
    char * getMsTimestamp();      // timestamp in millis, 14 digits char string
    
  private:
    uint16_t milliseconds = 0;        // used for extended timestamp (3 digits)
    uint32_t startMillis = millis();  // start millis for timer difference
    void calcMs();
};

#endif
