/** simpleTimeNtpWebRtcMillis **
 *  www.kendziorra.nl          *
 *  Ewald sr, 2018             *
 *  totally free to use        *
 *******************************/

#include "WebMs.h"

void WebMs::setTimestamp(time_t t) {;}  // DUMMY FUNCTION set time from UNIX timestamp
void WebMs::correctTime(int32_t s) {;}  // DUMMY FUNCTION time correction in seconds

WebMs::WebMs() {;}

time_t WebMs::getTimestamp() {
  boolean f = true;
  uint8_t i = 0;
  String d;
  calcMs();
  WiFiClient client;
  while (f && !client.connect("google.com", 80)) {delay(50); if (i++ == 10) f = false;}
  if (f) {
    client.print("HEAD / HTTP/1.1\r\n\r\n");
    i = 0;
    while(f && !client.available()) {delay(50); if (i++ == 10) f = false; }
    if (f && client.available()){
      client.findUntil("\nDate: ", "");
      client.findUntil(", ", "");
      d = client.readStringUntil('\r');
      client.stop();
      d = d.substring(0, d.length()- 4);
      /** parse date and time to int **/
      /** positions
       *  D  M   Y    h  m  s
       *  29 Jul 2017 21:08:03 
       *  012345678901234567890                
       *            1         2
       **/
      uint8_t D = d.substring(0, 2).toInt();
      uint8_t M = NameMonths.indexOf(d.substring(3, 6)) / 3 + 1;
      uint16_t Y = d.substring(7, 11).toInt();
      uint8_t h = d.substring(12, 14).toInt();
      uint8_t m = d.substring(15, 17).toInt();
      uint8_t s = d.substring(18).toInt();
      return calcTimeStamp(h, m, s, D, M, Y);
    }
  }
  return 0;
}

void WebMs::calcMs() {
  uint32_t stop, start, difference;
  stop = millis();
  start = startMillis;
  startMillis = millis();
  if(stop < start)  // overflow=true
    difference = (uint32_t)4294967295 - start + stop + 1;
  else                // overflow=false
    difference = stop - start; 
  difference += milliseconds; 
  milliseconds = difference % 1000;
  startMillis = millis() + 1; // + 0.001 sec. work time compensation
}

char * WebMs::getMsTimestamp() { // timestamp STRING in millis (UNIX * 1000)
  char msT[14];  // timestamp in millis, 14 digits char string
  char m[4];
  calcMs();
  ultoa(now(), msT, 10);
  ultoa(milliseconds, m, 10);
  strcat(msT, "000");
  strcpy(msT + 13 - strlen(m), m);  // add millis to the UNIXtimestamp
  return msT;
}

time_t WebMs::calcTimeStamp(uint8_t h, uint8_t m, uint8_t s, uint8_t D, uint8_t M, uint16_t Y) {  // get UNIX time_t Time Stamp from hh:mm:ss DD-MM-YY
  // UNIX timestamp = number of seconds since 1 Jan 00:00:00 1970
  if (Y < 100) Y += 2000;
  time_t t = 0;
  for (uint16_t i = 1970; i < Y; i++) t += yearDay(31, 12, i) * oneDay;
  return t + (yearDay(D, M, Y) - 1) * oneDay + (uint32_t)h * oneHour + (uint32_t)m * 60 + s;
}

uint16_t WebMs::yearDay(uint8_t d, uint8_t m, uint16_t y) {  // year days from date numbers
  int monthdays[13] = {0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334};
  return monthdays[m - 1] + (monthdays[m - 1] > 31 && leapYear(y) ? 1 : 0) + d;
}

boolean WebMs::leapYear(uint16_t y) {  // leap year?
  uint16_t Y = y < 100 ? y + 2000 : y;
  return ((Y % 4 == 0 && Y % 100 != 0) || Y % 400 == 0);
}

