/** simpleTimeNtpWebRtcMillis **
 *  www.kendziorra.nl          *
 *  Ewald sr, 2018             *
 *  totally free to use        *
 *******************************/

#ifndef WEB_TIME_H
#define WEB_TIME_H

#include <Arduino.h>
#include <ESP8266WiFi.h>
#include <TimeLib.h>  // https://github.com/PaulStoffregen/Time

class WebMs {
  public:
    WebMs();
    time_t getTimestamp();        // get UNIX timestamp
    void setTimestamp(time_t t);  // set time from UNIX timestamp
    void correctTime(int32_t s);  // time correction in seconds
    char * getMsTimestamp();      // timestamp in millis, 14 digits char string

  private:
    uint16_t syncOffset,        // time sync after each n seconds; small value = more precision
             milliseconds = 0;  // used for extended timestamp (3 digits)
    uint32_t startMillis = 0;   // start millis for timer difference
    const uint16_t oneHour = 3600;
    const uint32_t oneDay  = 86400;
    const String NameMonths = "JanFebMarAprMayJunJulAugSepOktNovDec";
    void calcMs();
    time_t calcTimeStamp(uint8_t h, uint8_t m, uint8_t s, uint8_t D, uint8_t M, uint16_t Y);  // get UNIX time_t Time Stamp from hh:mm:ss DD-MM-YY
    uint16_t yearDay(uint8_t d, uint8_t m, uint16_t y);  // year days from date numbers
    boolean leapYear(uint16_t y);  // leap year?
};

#endif
