#include "simpleTimers.h"

/** add a timer */
simpleTimers::simpleTimers(uint32_t ms, boolean start) {
  tmrOffset = ms;
  tmrStart(start);
}

/** start/stop a timer **/
void simpleTimers::tmrStart(boolean start) {
  if (start) {
    tmrRun = true;
    tmrMillis = millis();  
  }
  else tmrRun = false;
}

/** stop timer, set time, (start timer) **/
void simpleTimers::tmrReset(uint32_t ms, boolean start) {
  tmrStart(false);
  tmrOffset = ms;
  tmrStart(start);
}

/** get interval in millis **/
uint32_t simpleTimers::tmrMs() {
  return tmrOffset;
}

/** timers in millis **/
boolean simpleTimers::tmrTime() {
  boolean f = false;
  if (tmrRun && (getMillis(tmrMillis) >= tmrOffset)) {
    f = true;
    tmrMillis = millis();
  }
  return f;
}

/** get the millis after _start with overflow correction **/
uint32_t simpleTimers::getMillis(uint32_t _start) {  
  uint32_t _stop = millis();
  if (_stop < _start) return (uint32_t)4294967295 - _start + _stop + 1;
  else return _stop - _start;
}

